## elixir-lang 1.1.0~0.20150708

=== Makefile ===
REBAR ?= $(CURDIR)/rebar
PREFIX ?= /usr/local
DOCS := master
ELIXIRC := bin/elixirc --verbose --ignore-module-conflict
ERLC := erlc -I lib/elixir/include
ERL := erl -I lib/elixir/include -noshell -pa lib/elixir/ebin
VERSION := $(strip $(shell cat VERSION))
Q := @
LIBDIR := lib
INSTALL = install
INSTALL_DIR = $(INSTALL) -m755 -d
INSTALL_DATA = $(INSTALL) -m644
INSTALL_PROGRAM = $(INSTALL) -m755

.PHONY: install install_man compile erlang elixir build_plt clean_plt dialyze test clean docs release_docs release_zip check_erlang_release
.NOTPARALLEL: compile

#==> Functions

# This check should work for older versions like R16B
# as well as new verions like 17.1 and 18
define CHECK_ERLANG_RELEASE
	$(Q) erl -noshell -eval 'io:fwrite("~s", [erlang:system_info(otp_release)])' -s erlang halt | grep -q '^1[789]'; \
		if [ $$? != 0 ]; then                                                                                        \
		   echo "At least Erlang 17.0 is required to build Elixir";                                                  \
		   exit 1;                                                                                                   \
		fi;
endef

define APP_TEMPLATE
$(1): lib/$(1)/ebin/Elixir.$(2).beam lib/$(1)/ebin/$(1).app

lib/$(1)/ebin/$(1).app: lib/$(1)/mix.exs
	$(Q) mkdir -p lib/$(1)/_build/shared/lib/$(1)
	$(Q) cp -R lib/$(1)/ebin lib/$(1)/_build/shared/lib/$(1)/
	$(Q) cd lib/$(1) && ../../bin/elixir -e 'Mix.start(:permanent, [])' -r mix.exs -e 'Mix.Task.run("compile.app")'
	$(Q) cp lib/$(1)/_build/shared/lib/$(1)/ebin/$(1).app lib/$(1)/ebin/$(1).app
	$(Q) rm -rf lib/$(1)/_build

lib/$(1)/ebin/Elixir.$(2).beam: $(wildcard lib/$(1)/lib/*.ex) $(wildcard lib/$(1)/lib/*/*.ex) $(wildcard lib/$(1)/lib/*/*/*.ex)
	@ echo "==> $(1) (compile)"
	@ rm -rf lib/$(1)/ebin
	$(Q) cd lib/$(1) && ../../$$(ELIXIRC) "lib/**/*.ex" -o ebin

test_$(1): $(1)
	@ echo "==> $(1) (exunit)"
	$(Q) cd lib/$(1) && ../../bin/elixir -r "test/test_helper.exs" -pr "test/**/*_test.exs";
endef

#==> Compilation tasks

KERNEL:=lib/elixir/ebin/Elixir.Kernel.beam
UNICODE:=lib/elixir/ebin/Elixir.String.Unicode.beam

default: compile

compile: lib/elixir/src/elixir.app.src erlang elixir

lib/elixir/src/elixir.app.src: src/elixir.app.src
	$(Q) $(call CHECK_ERLANG_RELEASE)
	$(Q) rm -rf lib/elixir/src/elixir.app.src
	$(Q) echo "%% This file is automatically generated from <project_root>/src/elixir.app.src" \
	                             >lib/elixir/src/elixir.app.src
	$(Q) cat src/elixir.app.src >>lib/elixir/src/elixir.app.src

erlang:
	$(Q) cd lib/elixir && $(REBAR) compile

# Since Mix depends on EEx and EEx depends on
# Mix, we first compile EEx without the .app
# file, then mix and then compile EEx fully
elixir: stdlib lib/eex/ebin/Elixir.EEx.beam mix ex_unit logger eex iex

stdlib: $(KERNEL) VERSION
$(KERNEL): lib/elixir/lib/*.ex lib/elixir/lib/*/*.ex lib/elixir/lib/*/*/*.ex
	$(Q) if [ ! -f $(KERNEL) ]; then                    \
		echo "==> bootstrap (compile)";                 \
		$(ERL) -s elixir_compiler core -s erlang halt;  \
	fi
	@ echo "==> elixir (compile)";
	$(Q) cd lib/elixir && ../../$(ELIXIRC) "lib/kernel.ex" -o ebin;
	$(Q) cd lib/elixir && ../../$(ELIXIRC) "lib/**/*.ex" -o ebin;
	$(Q) $(MAKE) unicode
	$(Q) rm -rf lib/elixir/ebin/elixir.app
	$(Q) cd lib/elixir && $(REBAR) compile

unicode: $(UNICODE)
$(UNICODE): lib/elixir/unicode/*
	@ echo "==> unicode (compile)";
	@ echo "Embedding the Unicode database... (this may take a while)"
	$(Q) cd lib/elixir && ../../$(ELIXIRC) unicode/unicode.ex -o ebin;

$(eval $(call APP_TEMPLATE,ex_unit,ExUnit))
$(eval $(call APP_TEMPLATE,logger,Logger))
$(eval $(call APP_TEMPLATE,eex,EEx))
$(eval $(call APP_TEMPLATE,mix,Mix))
$(eval $(call APP_TEMPLATE,iex,IEx))

install: compile
	@ echo "==> elixir (install)"
	$(Q) for dir in lib/*; do \
		rm -Rf $(DESTDIR)$(PREFIX)/$(LIBDIR)/elixir/$$dir/ebin; \
		$(INSTALL_DIR) "$(DESTDIR)$(PREFIX)/$(LIBDIR)/elixir/$$dir/ebin"; \
		$(INSTALL_DATA) $$dir/ebin/* "$(DESTDIR)$(PREFIX)/$(LIBDIR)/elixir/$$dir/ebin"; \
	done
	$(Q) $(INSTALL_DIR) "$(DESTDIR)$(PREFIX)/$(LIBDIR)/elixir/bin"
	$(Q) $(INSTALL_PROGRAM) $(filter-out %.ps1, $(filter-out %.bat, $(wildcard bin/*))) "$(DESTDIR)$(PREFIX)/$(LIBDIR)/elixir/bin"
	$(Q) $(INSTALL_DIR) "$(DESTDIR)$(PREFIX)/bin"
	$(Q) for file in "$(DESTDIR)$(PREFIX)"/$(LIBDIR)/elixir/bin/* ; do \
		ln -sf "../$(LIBDIR)/elixir/bin/$${file##*/}" "$(DESTDIR)$(PREFIX)/bin/" ; \
	done
	$(MAKE) install_man

install_man:
	$(Q) mkdir -p $(DESTDIR)$(PREFIX)/share/man/man1
	cd man && $(MAKE) build
	$(Q) $(INSTALL_DATA) man/elixir.1  $(DESTDIR)$(PREFIX)/share/man/man1
	$(Q) $(INSTALL_DATA) man/elixirc.1 $(DESTDIR)$(PREFIX)/share/man/man1
	$(Q) $(INSTALL_DATA) man/iex.1     $(DESTDIR)$(PREFIX)/share/man/man1
	$(Q) $(INSTALL_DATA) man/mix.1     $(DESTDIR)$(PREFIX)/share/man/man1

clean:
	cd lib/elixir && $(REBAR) clean
	rm -rf ebin
	rm -rf lib/*/ebin
	rm -rf lib/elixir/test/ebin
	rm -rf lib/*/tmp
	rm -rf lib/mix/test/fixtures/git_repo
	rm -rf lib/mix/test/fixtures/deps_on_git_repo
	rm -rf lib/mix/test/fixtures/git_rebar
	rm -rf lib/elixir/src/elixir.app.src
	cd man && $(MAKE) clean

clean_exbeam:
	$(Q) rm -f lib/*/ebin/Elixir.*.beam

#==>  Create Documentation

SOURCE_REF = $(shell head="$$(git rev-parse HEAD)" tag="$$(git tag --points-at $$head | tail -1)" ; echo "$${tag:-$$head}\c")
COMPILE_DOCS = bin/elixir ../ex_doc/bin/ex_doc "$(1)" "$(VERSION)" "lib/$(2)/ebin" -m "$(3)" -u "https://github.com/elixir-lang/elixir" --source-ref "$(call SOURCE_REF)" -o doc/$(2) -p http://elixir-lang.org/docs.html

docs: compile ../ex_doc/bin/ex_doc docs_elixir docs_eex docs_mix docs_iex docs_ex_unit docs_logger

docs_elixir: compile ../ex_doc/bin/ex_doc
	@ echo "==> ex_doc (elixir)"
	$(Q) rm -rf doc/elixir
	$(call COMPILE_DOCS,Elixir,elixir,Kernel)

docs_eex: compile ../ex_doc/bin/ex_doc
	@ echo "==> ex_doc (eex)"
	$(Q) rm -rf doc/eex
	$(call COMPILE_DOCS,EEx,eex,EEx)

docs_mix: compile ../ex_doc/bin/ex_doc
	@ echo "==> ex_doc (mix)"
	$(Q) rm -rf doc/mix
	$(call COMPILE_DOCS,Mix,mix,Mix)

docs_iex: compile ../ex_doc/bin/ex_doc
	@ echo "==> ex_doc (iex)"
	$(Q) rm -rf doc/iex
	$(call COMPILE_DOCS,IEx,iex,IEx)

docs_ex_unit: compile ../ex_doc/bin/ex_doc
	@ echo "==> ex_doc (ex_unit)"
	$(Q) rm -rf doc/ex_unit
	$(call COMPILE_DOCS,ExUnit,ex_unit,ExUnit)

docs_logger: compile ../ex_doc/bin/ex_doc
	@ echo "==> ex_doc (logger)"
	$(Q) rm -rf doc/logger
	$(call COMPILE_DOCS,Logger,logger,Logger)

../ex_doc/bin/ex_doc:
	@ echo "ex_doc is not found in ../ex_doc as expected. See README for more information."
	@ false

#==> Release tasks

release_zip: compile
	rm -rf v$(VERSION).zip
	zip -9 -r v$(VERSION).zip bin CHANGELOG.md LEGAL lib/*/ebin LICENSE Makefile README.md VERSION

release_docs: docs
	rm -rf ../docs/$(DOCS)/*/
	mv doc/* ../docs/$(DOCS)

# This task requires aws-cli to be installed and set up for access to s3.hex.pm
# See: http://docs.aws.amazon.com/cli/latest/userguide/cli-chap-getting-set-up.html

publish_mix: compile
	cd lib/mix && MIX_ENV=prod mix escript.build
	aws s3 cp lib/mix/mix s3://s3.hex.pm/builds/mix/v$(VERSION)/mix --acl public-read
	aws s3 cp lib/mix/mix s3://s3.hex.pm/builds/mix/mix --acl public-read
	rm lib/mix/mix
	rm -rf lib/mix/_build

#==> Tests tasks

test: test_erlang test_elixir

TEST_ERL = lib/elixir/test/erlang
TEST_EBIN = lib/elixir/test/ebin
TEST_ERLS = $(addprefix $(TEST_EBIN)/, $(addsuffix .beam, $(basename $(notdir $(wildcard $(TEST_ERL)/*.erl)))))

test_erlang: compile $(TEST_ERLS)
	@ echo "==> elixir (eunit)"
	$(Q) $(ERL) -pa $(TEST_EBIN) -s test_helper test;
	@ echo ""

$(TEST_EBIN)/%.beam: $(TEST_ERL)/%.erl
	$(Q) mkdir -p $(TEST_EBIN)
	$(Q) $(ERLC) -o $(TEST_EBIN) $<

test_elixir: test_stdlib test_ex_unit test_logger test_doc_test test_mix test_eex test_iex

test_doc_test: compile
	@ echo "==> doctest (exunit)"
	$(Q) cd lib/elixir && ../../bin/elixir -r "test/doc_test.exs";

test_stdlib: compile
	@ echo "==> elixir (exunit)"
	$(Q) exec epmd & exit
	$(Q) if [ "$(OS)" = "Windows_NT" ]; then \
		cd lib/elixir && cmd //C call ../../bin/elixir.bat -r "test/elixir/test_helper.exs" -pr "test/elixir/**/*_test.exs"; \
	else \
		cd lib/elixir && ../../bin/elixir -r "test/elixir/test_helper.exs" -pr "test/elixir/**/*_test.exs"; \
	fi

#==> Dialyzer tasks

DIALYZER_OPTS = --no_check_plt --fullpath -Werror_handling -Wunmatched_returns -Wunderspecs
PLT = .elixir.plt

$(PLT):
	@ echo "==> Building PLT with Elixir's dependencies..."
	$(Q) dialyzer --output_plt $(PLT) --build_plt --apps erts kernel stdlib compiler syntax_tools parsetools tools ssl inets

clean_plt:
	$(Q) rm -f $(PLT)

build_plt: clean_plt $(PLT)

dialyze: compile $(PLT)
	@ echo "==> Dialyzing Elixir..."
	$(Q) dialyzer --plt $(PLT) $(DIALYZER_OPTS) lib/*/ebin

=== man/Makefile ===
Q := @

build:
	$(Q) cp iex.1.in iex.1
	$(Q) sed -i.bak "/{COMMON}/r common" iex.1
	$(Q) sed -i.bak "/{COMMON}/d" iex.1
	$(Q) cp elixir.1.in elixir.1
	$(Q) sed -i.bak "/{COMMON}/r common" elixir.1
	$(Q) sed -i.bak "/{COMMON}/d" elixir.1
	$(Q) rm *.bak

clean:
	rm -f elixir.1
	rm -f iex.1

=== debian/changelog ===
elixir-lang (1.1.0~0.20150708-1) unstable; urgency=medium

  * New upstream snapshot
    + fixed to work with Erlang/OTP 18 (Closes: #791626)

 -- Antonio Terceiro <terceiro@debian.org>  Wed, 08 Jul 2015 18:29:52 -0300

elixir-lang (1.1.0~0.20150516-1) unstable; urgency=medium

  * Initial release (Closes: #765522)

 -- Antonio Terceiro <terceiro@debian.org>  Sat, 16 May 2015 17:08:30 -0300

=== debian/control ===
Source: elixir-lang
Section: interpreters
Priority: optional
Maintainer: Antonio Terceiro <terceiro@debian.org>
Uploaders: Evgeny Golyshev <eugulixes@gmail.com>
Build-Depends: debhelper (>= 9~), erlang, erlang-dev, rebar, git
Standards-Version: 3.9.6
Vcs-Git: git://anonscm.debian.org/pkg-elixir/elixir.git
Vcs-Browser: http://anonscm.debian.org/cgit/pkg-elixir/elixir.git
Homepage: http://elixir-lang.org/
Testsuite: autopkgtest

Package: elixir
Architecture: any
Depends: erlang, ${shlibs:Depends}, ${misc:Depends}
Description: dynamic, functional language on top of the Erlang VM
 Elixir is a dynamic, functional language designed for building scalable and
 maintainable applications.
 .
 Elixir leverages the Erlang VM, known for running low-latency, distributed and
 fault-tolerant systems, while also being successfully used in web development
 and the embedded software domain.

=== debian/rules ===
#!/usr/bin/make -f

export LANG=C.UTF-8
export REBAR=/usr/bin/rebar
export PREFIX=/usr

%:
	dh $@

override_dh_auto_test: .home
	HOME=$(CURDIR)/.home dh_auto_test

override_dh_auto_clean:
	$(RM) -r .home
	dh_auto_clean

.home:
	mkdir $@

=== debian/tests/control ===
Tests: run-all

=== debian/watch ===
version=3
https://github.com/elixir-lang/elixir/releases/ .*/elixir/archive/v(.*).tar.gz

## elixir-lang 1.2.6

=== debian/changelog ===
elixir-lang (1.2.6-1) unstable; urgency=medium

  * Evgeny is now the maintainer

  [ Antonio Terceiro ]
  * New upstream release
  * Acknowledge Non-maintainer upload; thanks to Anton Gladky and Sergei
    Golovan.
  * debian/rules:
    - also set LC_ALL=C.UTF-8 since the VM requires UTF-8 for correct
      operation.
    - kill epmd after running tests here instead of with a patch to the
      Makefile (Closes: #819122)
  * debian/control:
    - Bump Standards-Version to 3.9.8, no other changes needed
    - Use https:// URL's for Vcs-*

  [ Evgeny Golyshev ]
  * Add patch disabling tests related to rebar3

 -- Antonio Terceiro <terceiro@debian.org>  Thu, 16 Jun 2016 09:48:49 -0300

elixir-lang (1.1.0-1.1) unstable; urgency=medium

  [ Anton Gladky ]
  * Non-maintainer upload.

  [ Sergei Golovan ]
  * Kill daemon after test phase. (Closes: #819122)

 -- Anton Gladky <gladk@debian.org>  Fri, 13 May 2016 21:02:10 +0200

elixir-lang (1.1.0-1) unstable; urgency=medium

  [ Evgeny Golyshev ]
  * Replace dependency on `erlang` with `erlang-base`. This avoids pulling
    several X11-related packages when installing on a headless system.
  * Improved package description

  [ Antonio Terceiro ]
  * New upstream release. This package will now be based on released upstream
    tarballs.
  * debian/watch: restrict to final releases
  * debian/copyright:
    - add `rebar` to Files-Excluded.
  * debian/control:
    - Switch Architecture: from `any` to `all`. Elixir code gets compiled to
      bytecode for the Erlang VM, so it is not architecture dependent.
    - Build-Depends:
      + remove `erlang` (but keep `erlang-dev)
      + add erlang-parsetools, erlang-eunit

 -- Antonio Terceiro <terceiro@debian.org>  Mon, 28 Sep 2015 11:14:32 -0300

=== debian/control ===
Source: elixir-lang
Section: interpreters
Priority: optional
Maintainer: Evgeny Golyshev <eugulixes@gmail.com>
Uploaders: Antonio Terceiro <terceiro@debian.org>
Build-Depends: debhelper (>= 9~),
               erlang-dev (>= 1:18),
               erlang-dialyzer (>= 1:18),
               erlang-eunit (>= 1:18),
               erlang-parsetools (>= 1:18),
               git,
               rebar
Standards-Version: 3.9.8
Vcs-Git: https://anonscm.debian.org/git/pkg-elixir/elixir.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-elixir/elixir.git
Homepage: http://elixir-lang.org/
Testsuite: autopkgtest

Package: elixir
Architecture: all
Depends: erlang-base (>= 1:18) | erlang-base-hipe (>= 1:18),
         ${misc:Depends}
Description: functional meta-programming aware language
 Elixir is a functional meta-programming aware language intended primarily for
 developing distributed, fault-tolerant and scalable systems. Elixir source
 code is compiled to bytecode for the Erlang Virtual Machine (EVM), and can use
 Erlang libraries transparently.

## elixir-lang 1.3.3

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,7 @@
-REBAR ?= $(CURDIR)/rebar
+REBAR ?= "$(CURDIR)/rebar"
 PREFIX ?= /usr/local
-DOCS := master
+DOCS := v1.3
+CANONICAL := stable
 ELIXIRC := bin/elixirc --verbose --ignore-module-conflict
 ERLC := erlc -I lib/elixir/include
 ERL := erl -I lib/elixir/include -noshell -pa lib/elixir/ebin
@@ -11,19 +12,19 @@
 INSTALL_DIR = $(INSTALL) -m755 -d
 INSTALL_DATA = $(INSTALL) -m644
 INSTALL_PROGRAM = $(INSTALL) -m755
-
-.PHONY: install install_man compile erlang elixir build_plt clean_plt dialyze test clean docs release_docs release_zip check_erlang_release
+GIT_REVISION = $(strip $(shell git rev-parse HEAD 2> /dev/null ))
+GIT_TAG = $(strip $(shell head="$(call GIT_REVISION)"; git tag --points-at $$head 2> /dev/null | tail -1) )
+
+.PHONY: install compile erlang elixir build_plt clean_plt dialyze test clean install_man clean_man docs Docs.zip Precompiled.zip publish_zips publish_docs publish_mix
 .NOTPARALLEL: compile
 
 #==> Functions
 
-# This check should work for older versions like R16B
-# as well as new verions like 17.1 and 18
 define CHECK_ERLANG_RELEASE
-	$(Q) erl -noshell -eval 'io:fwrite("~s", [erlang:system_info(otp_release)])' -s erlang halt | grep -q '^1[789]'; \
-		if [ $$? != 0 ]; then                                                                                        \
-		   echo "At least Erlang 17.0 is required to build Elixir";                                                  \
-		   exit 1;                                                                                                   \
+	$(Q) erl -noshell -eval 'io:fwrite("~s", [erlang:system_info(otp_release) >= "18"])' -s erlang halt | grep -q '^true'; \
+		if [ $$? != 0 ]; then \
+		   echo "At least Erlang 18.0 is required to build Elixir"; \
+		   exit 1; \
 		fi;
 endef
 
@@ -42,7 +43,7 @@
 	@ rm -rf lib/$(1)/ebin
 	$(Q) cd lib/$(1) && ../../$$(ELIXIRC) "lib/**/*.ex" -o ebin
 
-test_$(1): $(1)
+test_$(1): compile $(1)
 	@ echo "==> $(1) (exunit)"
 	$(Q) cd lib/$(1) && ../../bin/elixir -r "test/test_helper.exs" -pr "test/**/*_test.exs";
 endef
@@ -73,7 +74,7 @@
 
 stdlib: $(KERNEL) VERSION
 $(KERNEL): lib/elixir/lib/*.ex lib/elixir/lib/*/*.ex lib/elixir/lib/*/*/*.ex
-	$(Q) if [ ! -f $(KERNEL) ]; then                    \
+	$(Q) if [ ! -f $(KERNEL) ]; then                  \
 		echo "==> bootstrap (compile)";                 \
 		$(ERL) -s elixir_compiler core -s erlang halt;  \
 	fi
@@ -87,7 +88,6 @@
 unicode: $(UNICODE)
 $(UNICODE): lib/elixir/unicode/*
 	@ echo "==> unicode (compile)";
-	@ echo "Embedding the Unicode database... (this may take a while)"
 	$(Q) cd lib/elixir && ../../$(ELIXIRC) unicode/unicode.ex -o ebin;
 
 $(eval $(call APP_TEMPLATE,ex_unit,ExUnit))
@@ -111,14 +111,6 @@
 	done
 	$(MAKE) install_man
 
-install_man:
-	$(Q) mkdir -p $(DESTDIR)$(PREFIX)/share/man/man1
-	cd man && $(MAKE) build
-	$(Q) $(INSTALL_DATA) man/elixir.1  $(DESTDIR)$(PREFIX)/share/man/man1
-	$(Q) $(INSTALL_DATA) man/elixirc.1 $(DESTDIR)$(PREFIX)/share/man/man1
-	$(Q) $(INSTALL_DATA) man/iex.1     $(DESTDIR)$(PREFIX)/share/man/man1
-	$(Q) $(INSTALL_DATA) man/mix.1     $(DESTDIR)$(PREFIX)/share/man/man1
-
 clean:
 	cd lib/elixir && $(REBAR) clean
 	rm -rf ebin
@@ -129,22 +121,23 @@
 	rm -rf lib/mix/test/fixtures/deps_on_git_repo
 	rm -rf lib/mix/test/fixtures/git_rebar
 	rm -rf lib/elixir/src/elixir.app.src
-	cd man && $(MAKE) clean
+	$(MAKE) clean_man
 
 clean_exbeam:
 	$(Q) rm -f lib/*/ebin/Elixir.*.beam
 
-#==>  Create Documentation
-
-SOURCE_REF = $(shell head="$$(git rev-parse HEAD)" tag="$$(git tag --points-at $$head | tail -1)" ; echo "$${tag:-$$head}\c")
-COMPILE_DOCS = bin/elixir ../ex_doc/bin/ex_doc "$(1)" "$(VERSION)" "lib/$(2)/ebin" -m "$(3)" -u "https://github.com/elixir-lang/elixir" --source-ref "$(call SOURCE_REF)" -o doc/$(2) -p http://elixir-lang.org/docs.html
+#==> Create Documentation
+
+LOGO_PATH = $(shell test -f ../docs/logo.png && echo "--logo ../docs/logo.png")
+SOURCE_REF = $(shell tag="$(call GIT_TAG)" revision="$(call GIT_REVISION)"; echo "$${tag:-$$revision}\c")
+COMPILE_DOCS = bin/elixir ../ex_doc/bin/ex_doc "$(1)" "$(VERSION)" "lib/$(2)/ebin" -m "$(3)" -u "https://github.com/elixir-lang/elixir" --source-ref "$(call SOURCE_REF)" $(call LOGO_PATH) -o doc/$(2) -a http://elixir-lang.org/docs/$(CANONICAL)/$(2)/ -p http://elixir-lang.org/docs.html $(4)
 
 docs: compile ../ex_doc/bin/ex_doc docs_elixir docs_eex docs_mix docs_iex docs_ex_unit docs_logger
 
 docs_elixir: compile ../ex_doc/bin/ex_doc
 	@ echo "==> ex_doc (elixir)"
 	$(Q) rm -rf doc/elixir
-	$(call COMPILE_DOCS,Elixir,elixir,Kernel)
+	$(call COMPILE_DOCS,Elixir,elixir,Kernel,-e "lib/elixir/pages/Behaviours.md" -e "lib/elixir/pages/Naming Conventions.md" -e "lib/elixir/pages/Typespecs.md" -e "lib/elixir/pages/Writing Documentation.md")
 
 docs_eex: compile ../ex_doc/bin/ex_doc
 	@ echo "==> ex_doc (eex)"
@@ -175,25 +168,25 @@
 	@ echo "ex_doc is not found in ../ex_doc as expected. See README for more information."
 	@ false
 
-#==> Release tasks
-
-release_zip: compile
-	rm -rf v$(VERSION).zip
-	zip -9 -r v$(VERSION).zip bin CHANGELOG.md LEGAL lib/*/ebin LICENSE Makefile README.md VERSION
-
-release_docs: docs
+#==> Zips
+
+Docs.zip: docs
+	rm -rf Docs-v$(VERSION).zip
+	zip -9 -r Docs-v$(VERSION).zip CHANGELOG.md doc NOTICE LICENSE README.md
+	@ echo "Docs file created $(CURDIR)/Docs-v$(VERSION).zip"
+
+Precompiled.zip: build_man compile
+	rm -rf Precompiled-v$(VERSION).zip
+	zip -9 -r Precompiled-v$(VERSION).zip bin CHANGELOG.md lib/*/ebin LICENSE man NOTICE README.md VERSION
+	@ echo "Precompiled file created $(CURDIR)/Precompiled-v$(VERSION).zip"
+
+#==> Publish
+
+publish_zips: Precompiled.zip Docs.zip
+
+publish_docs: docs
 	rm -rf ../docs/$(DOCS)/*/
-	mv doc/* ../docs/$(DOCS)
-
-# This task requires aws-cli to be installed and set up for access to s3.hex.pm
-# See: http://docs.aws.amazon.com/cli/latest/userguide/cli-chap-getting-set-up.html
-
-publish_mix: compile
-	cd lib/mix && MIX_ENV=prod mix escript.build
-	aws s3 cp lib/mix/mix s3://s3.hex.pm/builds/mix/v$(VERSION)/mix --acl public-read
-	aws s3 cp lib/mix/mix s3://s3.hex.pm/builds/mix/mix --acl public-read
-	rm lib/mix/mix
-	rm -rf lib/mix/_build
+	cp -R doc/* ../docs/$(DOCS)
 
 #==> Tests tasks
 
@@ -212,11 +205,7 @@
 	$(Q) mkdir -p $(TEST_EBIN)
 	$(Q) $(ERLC) -o $(TEST_EBIN) $<
 
-test_elixir: test_stdlib test_ex_unit test_logger test_doc_test test_mix test_eex test_iex
-
-test_doc_test: compile
-	@ echo "==> doctest (exunit)"
-	$(Q) cd lib/elixir && ../../bin/elixir -r "test/doc_test.exs";
+test_elixir: test_stdlib test_ex_unit test_logger test_mix test_eex test_iex
 
 test_stdlib: compile
 	@ echo "==> elixir (exunit)"
@@ -244,3 +233,31 @@
 dialyze: compile $(PLT)
 	@ echo "==> Dialyzing Elixir..."
 	$(Q) dialyzer --plt $(PLT) $(DIALYZER_OPTS) lib/*/ebin
+
+#==> Man page tasks
+
+build_man: man/iex.1 man/elixir.1
+
+man/iex.1:
+	$(Q) cp man/iex.1.in man/iex.1
+	$(Q) sed -i.bak "/{COMMON}/r common" man/iex.1
+	$(Q) sed -i.bak "/{COMMON}/d" man/iex.1
+	$(Q) rm man/iex.1.bak
+
+man/elixir.1:
+	$(Q) cp man/elixir.1.in man/elixir.1
+	$(Q) sed -i.bak "/{COMMON}/r common" man/elixir.1
+	$(Q) sed -i.bak "/{COMMON}/d" man/elixir.1
+	$(Q) rm man/elixir.1.bak
+
+clean_man:
+	rm -f man/elixir.1
+	rm -f man/iex.1
+
+install_man: build_man
+	$(Q) mkdir -p $(DESTDIR)$(PREFIX)/share/man/man1
+	$(Q) $(INSTALL_DATA) man/elixir.1  $(DESTDIR)$(PREFIX)/share/man/man1
+	$(Q) $(INSTALL_DATA) man/elixirc.1 $(DESTDIR)$(PREFIX)/share/man/man1
+	$(Q) $(INSTALL_DATA) man/iex.1     $(DESTDIR)$(PREFIX)/share/man/man1
+	$(Q) $(INSTALL_DATA) man/mix.1     $(DESTDIR)$(PREFIX)/share/man/man1
+	$(MAKE) clean_man

=== debian/changelog ===
elixir-lang (1.3.3-2) unstable; urgency=medium

  * Add erlang-crypto to Build-Depends (Closes: #837236)

 -- Evgeny Golyshev <eugulixes@gmail.com>  Wed, 05 Oct 2016 22:43:17 +0300

elixir-lang (1.3.3-1) unstable; urgency=medium

  * New upstream release
  * Add patch disabling tests related to rebar3

 -- Evgeny Golyshev <eugulixes@gmail.com>  Sun, 18 Sep 2016 16:25:14 +0300

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
 Maintainer: Evgeny Golyshev <eugulixes@gmail.com>
 Uploaders: Antonio Terceiro <terceiro@debian.org>
 Build-Depends: debhelper (>= 9~),
+               erlang-crypto (>= 1:18),
                erlang-dev (>= 1:18),
                erlang-dialyzer (>= 1:18),
                erlang-eunit (>= 1:18),

=== debian/rules ===
#!/usr/bin/make -f

export LANG=C.UTF-8
export LC_ALL=C.UTF-8
export REBAR=/usr/bin/rebar
export PREFIX=/usr

%:
	dh $@

override_dh_auto_test: .home
	rc=0; HOME=$(CURDIR)/.home dh_auto_test || rc=$$?; epmd -kill; exit $$rc

override_dh_auto_clean:
	$(RM) -r .home
	dh_auto_clean

.home:
	mkdir $@

=== debian/watch ===
version=3
https://github.com/elixir-lang/elixir/releases/ .*/elixir/archive/v([0-9.]*).tar.gz

## elixir-lang 1.3.3+really1.10.3

=== debian/changelog ===
elixir-lang (1.3.3+really1.10.3-0+deb9u1) stretch-security; urgency=high

  * Non-maintainer upload.
  * New upstream version. Required to build latest rabbitmq-server in Stretch.

 -- Markus Koschany <apo@debian.org>  Thu, 01 Dec 2022 22:08:40 +0100

elixir-lang (1.10.3.dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Remove dependency of the elixir binary package on erlang-pcre-<version>,
    because it isn't necessary anymore (closes: #963043).

 -- Sergei Golovan <sgolovan@debian.org>  Thu, 18 Jun 2020 18:22:53 +0300

elixir-lang (1.10.3.dfsg-1) unstable; urgency=medium

  * New upstream release (closes: #959701, #959160, #959988).
  * Remove patches/remove-test-executes-rpc-instructions.patch.
  * Require Erlang 21.0 or later.

 -- Evgeny Golyshev <eugulixes@gmail.com>  Wed, 06 May 2020 20:33:40 +0300

elixir-lang (1.9.1.dfsg-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Add remove-test-executes-rpc-instructions.patch, as this test reliably
    fails on arm64 and mips64el.

 -- Thomas Goirand <zigo@debian.org>  Mon, 04 Nov 2019 11:27:07 +0100

elixir-lang (1.9.1.dfsg-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Re-attempt unit testing (up to 3 times) if failed (Closes: #942688).

 -- Thomas Goirand <zigo@debian.org>  Wed, 30 Oct 2019 12:23:33 +0100

elixir-lang (1.9.1.dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add a dependency of the elixir binary package on erlang-pcre-<version>
    virtual package to prevent installation when PCRE in Erlang changes,
    invalidating precompiled regexes (closes: #941124).
  * Move to ${erlang:Depends} substitution variable to calculate the
    dependencies automatically.

 -- Sergei Golovan <sgolovan@debian.org>  Sun, 13 Oct 2019 09:39:24 +0300

elixir-lang (1.9.1.dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Elixir is endianness-dependent, so substitute 'Architecture: all' for
    'Architecture: any' in debian/control.
  * Increase version number of Erlang in debian/control.
  * Remove disable_tests_to_prevent_failing_with_erlang_22.patch.
  * Adapt remove_rebar3_related_tests.patch to the current Elixir release.
  * Improve debian/tests/run-all
    - do cleanup more carefully after running tests;
    - do cleanup on the following signals: SIGHUP, SIGINT, SIGQUIT and SIGABRT;
    - use bash instead of dash.

 -- Evgeny Golyshev <eugulixes@gmail.com>  Fri, 19 Jul 2019 13:29:07 +0300

elixir-lang (1.7.4.dfsg-2) unstable; urgency=medium

  * Fix debian/tests/run-all to make it run tests properly.

 -- Evgeny Golyshev <eugulixes@gmail.com>  Thu, 18 Jul 2019 12:36:34 +0300

elixir-lang (1.7.4.dfsg-1) unstable; urgency=medium

  * Apply patch provided by Tomas Janousek (Closes: #930497)
    - The patch makes Elixir explicitly depend on
      erlang-base:any | erlang-base-hipe:any
  * Exclude lib/mix/test/fixtures/rebar and lib/mix/test/fixtures/rebar3.
  * Specify license for lib/elixir/unicode/*.txt in debian/copyright.
  * Add remove_rebar3_related_tests.patch not to run the rebar3 related
    tests because we don't have rebar3.
  * Add use_rebar_instead_of_rebar3_in_tests.patch to fix the bug which
    made the Mix tests use only rebar3.
  * Add .dfsg suffix to the package version number to make it clear that
    the upstream archive must be repacked with the purpose of removing
    such binaries as rebar and rebar3.
  * Add disable_tests_to_prevent_failing_with_erlang_22.patch to disable the
    tests which fail under Erlang/OTP 22.

 -- Evgeny Golyshev <eugulixes@gmail.com>  Sun, 14 Jul 2019 23:38:27 +0300

elixir-lang (1.7.4-0.1) unstable; urgency=medium

  * Non-maintainer upload with authorization from current maintainer.
  * New upstream release:
    - Fixes FTBFS (Closes: #910307).
  * Removed all patches.
  * Add patch to remove the UTF-8 warning (Closes: #912207).

 -- Thomas Goirand <zigo@debian.org>  Tue, 30 Oct 2018 07:56:01 +0000

elixir-lang (1.6.5-1) unstable; urgency=medium

  [ Antonio Terceiro ]
  * Drop myself from the Uploaders field

  [ Evgeny Golyshev ]
  * New upstream release (Closes: #869030)
    - The tests from the latest version with newer dependencies seem to be
      fine again (Closes: #871120)
  * Substitute alioth for salsa in Vcs-Browser and Vcs-Git fields
  * Add debian/upstream/metadata
  * Remove Testsuite from debian/control
  * Bump Standards-Version to 4.1.4
  * Bump compat version to 10
  * Add docs file containing NOTICE
  * Use only https in Format field of debian/copyright
  * Do not mention lib/elixir/src/elixir_parser.erl in debian/copyright
  * Disable one more rebar3 related test
  * Temporarily disable rebar related test

 -- Evgeny Golyshev <eugulixes@gmail.com>  Wed, 09 May 2018 23:22:08 +0300

=== debian/control ===
Source: elixir-lang
Section: interpreters
Priority: optional
Maintainer: Evgeny Golyshev <eugulixes@gmail.com>
Build-Depends: debhelper (>= 10),
               erlang-crypto (>= 1:19.2.1+dfsg-2+really23.3.4.18),
               erlang-dev (>= 1:19.2.1+dfsg-2+really23.3.4.18),
               erlang-dialyzer (>= 1:19.2.1+dfsg-2+really23.3.4.18),
               erlang-eunit (>= 1:19.2.1+dfsg-2+really23.3.4.18),
               erlang-parsetools (>= 1:19.2.1+dfsg-2+really23.3.4.18),
               erlang-src (>= 1:19.2.1+dfsg-2+really23.3.4.18),
               git,
               rebar
Standards-Version: 4.1.4
Vcs-Git: https://salsa.debian.org/eugulixes-guest/elixir-lang.git
Vcs-Browser: https://salsa.debian.org/eugulixes-guest/elixir-lang
Homepage: http://elixir-lang.org/

Package: elixir
Architecture: any
Depends: ${erlang:Depends}, ${misc:Depends}
Description: functional meta-programming aware language
 Elixir is a functional meta-programming aware language intended primarily for
 developing distributed, fault-tolerant and scalable systems. Elixir source
 code is compiled to bytecode for the Erlang Virtual Machine (EVM), and can use
 Erlang libraries transparently.

=== debian/rules ===
#!/usr/bin/make -f

export LANG=C.UTF-8
export LC_ALL=C.UTF-8
export REBAR=/usr/bin/rebar
export PREFIX=/usr

%:
	dh $@


override_dh_auto_test:

#override_dh_auto_test: .home
#	CNT=3 ; rc=1 ; while [ $$CNT != 0 ] && [ $$rc != 0 ] ; do \
#		if HOME=$(CURDIR)/.home dh_auto_test ; then \
#			rc=0 ; \
#		else \
#			rc=1 ; \
#			epmd -kill ; \
#		fi ; \
#		CNT=$$(( $$CNT - 1)) ; \
#	done ; \
#	if [ $${rc} != 0 ] ; then exit $$rc ; else epmd -kill ; fi

override_dh_auto_clean:
	$(RM) -r .home
	dh_auto_clean

override_dh_shlibdeps:
	dh_shlibdeps
	erlang-depends

.home:
	mkdir $@

## elixir-lang 1.7.4

=== Makefile ===
PREFIX ?= /usr/local
SHARE_PREFIX ?= $(PREFIX)/share
CANONICAL := v1.7/
ELIXIRC := bin/elixirc --verbose --ignore-module-conflict
ERLC := erlc -I lib/elixir/include
ERL := erl -I lib/elixir/include -noshell -pa lib/elixir/ebin
GENERATE_APP := $(CURDIR)/lib/elixir/generate_app.escript
VERSION := $(strip $(shell cat VERSION))
Q := @
LIBDIR := lib
BINDIR := bin
INSTALL = install
INSTALL_DIR = $(INSTALL) -m755 -d
INSTALL_DATA = $(INSTALL) -m644
INSTALL_PROGRAM = $(INSTALL) -m755
GIT_REVISION = $(strip $(shell git rev-parse HEAD 2> /dev/null ))
GIT_TAG = $(strip $(shell head="$(call GIT_REVISION)"; git tag --points-at $$head 2> /dev/null | tail -1) )

.PHONY: install compile erlang elixir unicode app build_plt clean_plt dialyze test clean clean_residual_files install_man clean_man docs Docs.zip Precompiled.zip zips
.NOTPARALLEL: compile

#==> Functions

define CHECK_ERLANG_RELEASE
	erl -noshell -eval '{V,_} = string:to_integer(erlang:system_info(otp_release)), io:fwrite("~s", [is_integer(V) and (V >= 19)])' -s erlang halt | grep -q '^true'; \
		if [ $$? != 0 ]; then \
		  echo "At least Erlang/OTP 19.0 is required to build Elixir"; \
		  exit 1; \
		fi
endef

define APP_TEMPLATE
$(1): lib/$(1)/ebin/Elixir.$(2).beam lib/$(1)/ebin/$(1).app

lib/$(1)/ebin/$(1).app: lib/$(1)/mix.exs
	$(Q) mkdir -p lib/$(1)/_build/shared/lib/$(1)
	$(Q) cp -R lib/$(1)/ebin lib/$(1)/_build/shared/lib/$(1)/
	$(Q) cd lib/$(1) && ../../bin/elixir -e 'Mix.start(:permanent, [])' -r mix.exs -e 'Mix.Task.run("compile.app")'
	$(Q) cp lib/$(1)/_build/shared/lib/$(1)/ebin/$(1).app lib/$(1)/ebin/$(1).app
	$(Q) rm -rf lib/$(1)/_build

lib/$(1)/ebin/Elixir.$(2).beam: $(wildcard lib/$(1)/lib/*.ex) $(wildcard lib/$(1)/lib/*/*.ex) $(wildcard lib/$(1)/lib/*/*/*.ex)
	@ echo "==> $(1) (compile)"
	@ rm -rf lib/$(1)/ebin
	$(Q) cd lib/$(1) && ../../$$(ELIXIRC) "lib/**/*.ex" -o ebin

test_$(1): compile $(1)
	@ echo "==> $(1) (exunit)"
	$(Q) cd lib/$(1) && ../../bin/elixir -r "test/test_helper.exs" -pr "test/**/*_test.exs";
endef

#==> Compilation tasks

APP := lib/elixir/ebin/elixir.app
PARSER := lib/elixir/src/elixir_parser.erl
KERNEL := lib/elixir/ebin/Elixir.Kernel.beam
UNICODE := lib/elixir/ebin/Elixir.String.Unicode.beam

default: compile

compile: erlang $(APP) elixir

erlang: $(PARSER)
	$(Q) if [ ! -f $(APP) ]; then $(call CHECK_ERLANG_RELEASE); fi
	$(Q) cd lib/elixir && mkdir -p ebin && erl -make

$(PARSER): lib/elixir/src/elixir_parser.yrl
	$(Q) erlc -o $@ +'{verbose,true}' +'{report,true}' $<

# Since Mix depends on EEx and EEx depends on Mix,
# we first compile EEx without the .app file,
# then Mix and then compile EEx fully
elixir: stdlib lib/eex/ebin/Elixir.EEx.beam mix ex_unit logger eex iex

stdlib: $(KERNEL) VERSION
$(KERNEL): lib/elixir/lib/*.ex lib/elixir/lib/*/*.ex lib/elixir/lib/*/*/*.ex
	$(Q) if [ ! -f $(KERNEL) ]; then \
		echo "==> bootstrap (compile)"; \
		$(ERL) -s elixir_compiler bootstrap -s erlang halt; \
	fi
	@ echo "==> elixir (compile)";
	$(Q) cd lib/elixir && ../../$(ELIXIRC) "lib/kernel.ex" -o ebin;
	$(Q) cd lib/elixir && ../../$(ELIXIRC) "lib/**/*.ex" -o ebin;
	$(Q) $(MAKE) unicode
	$(Q) $(MAKE) app

app: $(APP)
$(APP): lib/elixir/src/elixir.app.src lib/elixir/ebin VERSION $(GENERATE_APP)
	$(Q) $(GENERATE_APP) $< $@ $(VERSION)

unicode: $(UNICODE)
$(UNICODE): lib/elixir/unicode/*
	@ echo "==> unicode (compile)";
	$(Q) $(ELIXIRC) lib/elixir/unicode/unicode.ex -o lib/elixir/ebin;
	$(Q) $(ELIXIRC) lib/elixir/unicode/properties.ex -o lib/elixir/ebin;
	$(Q) $(ELIXIRC) lib/elixir/unicode/tokenizer.ex -o lib/elixir/ebin;

$(eval $(call APP_TEMPLATE,ex_unit,ExUnit))
$(eval $(call APP_TEMPLATE,logger,Logger))
$(eval $(call APP_TEMPLATE,eex,EEx))
$(eval $(call APP_TEMPLATE,mix,Mix))
$(eval $(call APP_TEMPLATE,iex,IEx))

install: compile
	@ echo "==> elixir (install)"
	$(Q) for dir in lib/*; do \
		rm -rf $(DESTDIR)$(PREFIX)/$(LIBDIR)/elixir/$$dir/ebin; \
		$(INSTALL_DIR) "$(DESTDIR)$(PREFIX)/$(LIBDIR)/elixir/$$dir/ebin"; \
		$(INSTALL_DATA) $$dir/ebin/* "$(DESTDIR)$(PREFIX)/$(LIBDIR)/elixir/$$dir/ebin"; \
	done
	$(Q) $(INSTALL_DIR) "$(DESTDIR)$(PREFIX)/$(LIBDIR)/elixir/bin"
	$(Q) $(INSTALL_PROGRAM) $(filter-out %.ps1, $(filter-out %.bat, $(wildcard bin/*))) "$(DESTDIR)$(PREFIX)/$(LIBDIR)/elixir/bin"
	$(Q) $(INSTALL_DIR) "$(DESTDIR)$(PREFIX)/$(BINDIR)"
	$(Q) for file in "$(DESTDIR)$(PREFIX)"/$(LIBDIR)/elixir/bin/*; do \
		ln -sf "../$(LIBDIR)/elixir/bin/$${file##*/}" "$(DESTDIR)$(PREFIX)/$(BINDIR)/"; \
	done
	$(MAKE) install_man

clean:
	rm -rf ebin
	rm -rf lib/*/ebin
	rm -rf $(PARSER)
	$(Q) $(MAKE) clean_residual_files

clean_elixir:
	$(Q) rm -f lib/*/ebin/Elixir.*.beam

clean_residual_files:
	rm -rf lib/*/_build/
	rm -rf lib/*/tmp/
	rm -rf lib/elixir/test/ebin/
	rm -rf lib/mix/test/fixtures/deps_on_git_repo/
	rm -rf lib/mix/test/fixtures/git_rebar/
	rm -rf lib/mix/test/fixtures/git_repo/
	rm -rf lib/mix/test/fixtures/git_sparse_repo/
	rm -f erl_crash.dump
	$(Q) $(MAKE) clean_man

#==> Documentation tasks

LOGO_PATH = $(shell test -f ../docs/logo.png && echo "--logo ../docs/logo.png")
SOURCE_REF = $(shell tag="$(call GIT_TAG)" revision="$(call GIT_REVISION)"; echo "$${tag:-$$revision}\c")
DOCS_FORMAT = html
COMPILE_DOCS = bin/elixir ../ex_doc/bin/ex_doc "$(1)" "$(VERSION)" "lib/$(2)/ebin" -m "$(3)" -u "https://github.com/elixir-lang/elixir" --source-ref "$(call SOURCE_REF)" $(call LOGO_PATH) -o doc/$(2) -n https://hexdocs.pm/$(2)/$(CANONICAL) -p http://elixir-lang.org/docs.html -f "$(DOCS_FORMAT)" $(4)

docs: compile ../ex_doc/bin/ex_doc docs_elixir docs_eex docs_mix docs_iex docs_ex_unit docs_logger

docs_elixir: compile ../ex_doc/bin/ex_doc
	@ echo "==> ex_doc (elixir)"
	$(Q) rm -rf doc/elixir
	$(call COMPILE_DOCS,Elixir,elixir,Kernel,-c lib/elixir/docs.exs)

docs_eex: compile ../ex_doc/bin/ex_doc
	@ echo "==> ex_doc (eex)"
	$(Q) rm -rf doc/eex
	$(call COMPILE_DOCS,EEx,eex,EEx)

docs_mix: compile ../ex_doc/bin/ex_doc
	@ echo "==> ex_doc (mix)"
	$(Q) rm -rf doc/mix
	$(call COMPILE_DOCS,Mix,mix,Mix)

docs_iex: compile ../ex_doc/bin/ex_doc
	@ echo "==> ex_doc (iex)"
	$(Q) rm -rf doc/iex
	$(call COMPILE_DOCS,IEx,iex,IEx)

docs_ex_unit: compile ../ex_doc/bin/ex_doc
	@ echo "==> ex_doc (ex_unit)"
	$(Q) rm -rf doc/ex_unit
	$(call COMPILE_DOCS,ExUnit,ex_unit,ExUnit)

docs_logger: compile ../ex_doc/bin/ex_doc
	@ echo "==> ex_doc (logger)"
	$(Q) rm -rf doc/logger
	$(call COMPILE_DOCS,Logger,logger,Logger)

../ex_doc/bin/ex_doc:
	@ echo "ex_doc is not found in ../ex_doc as expected. See README for more information."
	@ false

#==> Zip tasks

Docs.zip: docs
	rm -f Docs-v$(VERSION).zip
	zip -9 -r Docs-v$(VERSION).zip CHANGELOG.md doc NOTICE LICENSE README.md
	@ echo "Docs file created $(CURDIR)/Docs-v$(VERSION).zip"

Precompiled.zip: build_man compile
	rm -f Precompiled-v$(VERSION).zip
	zip -9 -r Precompiled-v$(VERSION).zip bin CHANGELOG.md lib/*/ebin lib/*/lib LICENSE man NOTICE README.md VERSION
	@ echo "Precompiled file created $(CURDIR)/Precompiled-v$(VERSION).zip"

zips: Precompiled.zip Docs.zip
	@ echo ""
	@ echo "## Checksums"
	@ echo ""
	@ shasum -a 1 < Precompiled-v$(VERSION).zip | sed -e "s/-//" | xargs echo "  * Precompiled.zip SHA1:"
	@ shasum -a 512 < Precompiled-v$(VERSION).zip | sed -e "s/-//" | xargs echo "  * Precompiled.zip SHA512:"
	@ shasum -a 1 < Docs-v$(VERSION).zip | sed -e "s/-//" | xargs echo "  * Docs.zip SHA1:"
	@ shasum -a 512 < Docs-v$(VERSION).zip | sed -e "s/-//" | xargs echo "  * Docs.zip SHA512:"
	@ echo ""

#==> Test tasks

test: test_formatted test_erlang test_elixir

test_windows: test test_taskkill

test_taskkill:
	taskkill //IM erl.exe //F //T //FI "MEMUSAGE gt 0"
	taskkill //IM epmd.exe //F //T //FI "MEMUSAGE gt 0"

TEST_ERL = lib/elixir/test/erlang
TEST_EBIN = lib/elixir/test/ebin
TEST_ERLS = $(addprefix $(TEST_EBIN)/, $(addsuffix .beam, $(basename $(notdir $(wildcard $(TEST_ERL)/*.erl)))))

test_formatted: compile
	bin/elixir bin/mix format --check-formatted

test_erlang: compile $(TEST_ERLS)
	@ echo "==> elixir (eunit)"
	$(Q) $(ERL) -pa $(TEST_EBIN) -s test_helper test;
	@ echo ""

$(TEST_EBIN)/%.beam: $(TEST_ERL)/%.erl
	$(Q) mkdir -p $(TEST_EBIN)
	$(Q) $(ERLC) -o $(TEST_EBIN) $<

test_elixir: test_stdlib test_ex_unit test_logger test_mix test_eex test_iex

test_stdlib: compile
	@ echo "==> elixir (exunit)"
	$(Q) exec epmd & exit
	$(Q) if [ "$(OS)" = "Windows_NT" ]; then \
		cd lib/elixir && cmd //C call ../../bin/elixir.bat -r "test/elixir/test_helper.exs" -pr "test/elixir/**/*_test.exs"; \
	else \
		cd lib/elixir && ../../bin/elixir -r "test/elixir/test_helper.exs" -pr "test/elixir/**/*_test.exs"; \
	fi

#==> Dialyzer tasks

DIALYZER_OPTS = --no_check_plt --fullpath -Werror_handling -Wunmatched_returns -Wunderspecs
PLT = .elixir.plt

$(PLT):
	@ echo "==> Building PLT with Elixir's dependencies..."
	$(Q) dialyzer --output_plt $(PLT) --build_plt --apps erts kernel stdlib compiler syntax_tools parsetools tools ssl inets

clean_plt:
	$(Q) rm -f $(PLT)

build_plt: clean_plt $(PLT)

dialyze: compile $(PLT)
	@ echo "==> Dialyzing Elixir..."
	$(Q) dialyzer --plt $(PLT) $(DIALYZER_OPTS) lib/*/ebin

#==> Man page tasks

build_man: man/iex.1 man/elixir.1

man/iex.1:
	$(Q) cp man/iex.1.in man/iex.1
	$(Q) sed -i.bak "/{COMMON}/r man/common" man/iex.1
	$(Q) sed -i.bak "/{COMMON}/d" man/iex.1
	$(Q) rm -f man/iex.1.bak

man/elixir.1:
	$(Q) cp man/elixir.1.in man/elixir.1
	$(Q) sed -i.bak "/{COMMON}/r man/common" man/elixir.1
	$(Q) sed -i.bak "/{COMMON}/d" man/elixir.1
	$(Q) rm -f man/elixir.1.bak

clean_man:
	rm -f man/elixir.1
	rm -f man/elixir.1.bak
	rm -f man/iex.1
	rm -f man/iex.1.bak

install_man: build_man
	$(Q) mkdir -p $(DESTDIR)$(SHARE_PREFIX)/man/man1
	$(Q) $(INSTALL_DATA) man/elixir.1  $(DESTDIR)$(SHARE_PREFIX)/man/man1
	$(Q) $(INSTALL_DATA) man/elixirc.1 $(DESTDIR)$(SHARE_PREFIX)/man/man1
	$(Q) $(INSTALL_DATA) man/iex.1     $(DESTDIR)$(SHARE_PREFIX)/man/man1
	$(Q) $(INSTALL_DATA) man/mix.1     $(DESTDIR)$(SHARE_PREFIX)/man/man1
	$(MAKE) clean_man

=== debian/changelog ===
elixir-lang (1.7.4-0.1+deb10u1) buster-security; urgency=medium

  * Non-maintainer upload by the LTS team.
  * Tighten build-dependency on erlang 1:22.2.7+dfsg-1+deb10u1.

 -- Markus Koschany <apo@debian.org>  Sat, 08 Jul 2023 18:50:16 +0200

=== debian/control ===
Source: elixir-lang
Section: interpreters
Priority: optional
Maintainer: Evgeny Golyshev <eugulixes@gmail.com>
Build-Depends: debhelper (>= 10),
               erlang-crypto (>= 1:22),
               erlang-dev (>= 1:22),
               erlang-dialyzer (>= 1:22),
               erlang-eunit (>= 1:22),
               erlang-parsetools (>= 1:22),
               erlang-src (>= 1:22),
               git,
               rebar
Standards-Version: 4.1.4
Vcs-Git: https://salsa.debian.org/eugulixes-guest/elixir-lang.git
Vcs-Browser: https://salsa.debian.org/eugulixes-guest/elixir-lang
Homepage: http://elixir-lang.org/

Package: elixir
Architecture: all
Depends: erlang-base (>= 1:22) | erlang-base-hipe (>= 1:22),
         ${misc:Depends}
Description: functional meta-programming aware language
 Elixir is a functional meta-programming aware language intended primarily for
 developing distributed, fault-tolerant and scalable systems. Elixir source
 code is compiled to bytecode for the Erlang Virtual Machine (EVM), and can use
 Erlang libraries transparently.

=== debian/rules ===
#!/usr/bin/make -f

export LANG=C.UTF-8
export LC_ALL=C.UTF-8
export REBAR=/usr/bin/rebar
export PREFIX=/usr

%:
	dh $@

override_dh_auto_test: .home
	# The current test failures can be ignored. Re-enable when testing new
	# updates
	#rc=0; HOME=$(CURDIR)/.home dh_auto_test || rc=$$?; epmd -kill; exit $$rc

override_dh_auto_clean:
	$(RM) -r .home
	dh_auto_clean

.home:
	mkdir $@
